/**
 * BitStringUtil
 * 
 * @author Taylor Born
 * @version April 2013
 */
public abstract class BitStringUtil
{
    protected static final int BITS_PER_CHAR = 7;
    protected static final String CARRIAGE_RETURN_LEAD = "000110"; // bitString leading to charriage-return char
    protected static final String SUB_TO_AVOID_CARRIAGE_RETURN = "0001100";
    protected static final String BACKSLASH_LEAD = "101110"; // bitString leading to backslash char
    protected static final String SUB_TO_AVOID_BACKSLASH = "1011101";
    
    /**
     * @param s String of 1s and 0s.
     * @return Number according to input base 2.
     */
    public static int bitStringToNumber(String s)
    {
        int n = 0;
        for (int i = 0; i < s.length(); i++)
            if (s.charAt(i) == '1')
                n += Math.pow(2, s.length() - 1 - i);
        return n;
    }
    
    /**
     * @param n The number to be converted to base 2.
     * @param i Greatest power of 2 to consider. (Length of return String).
     * @return String of 1s and 0s representing inputed number, base 2.
     */
    public static String numberToBitString(int n, int i)
    {
        String s = "";
        for (i = i - 1; i > -1; i--)
            if (n >= Math.pow(2, i))
            {
                s += '1';
                n -= Math.pow(2, i);
            }
            else
                s += '0';
        return s;
    }
    
    /**
     * 
     */
    public static int encodeBitStringTo32BitInt(String bitString)
    {
        if (bitString == null || bitString.length() != 32)
            throw new IllegalArgumentException("Argument must represent 32 bits (1s and 0s).");
        int num = 0;
        for (int i = 0; i < 32; i++)
        {
            num = num << 1;
            if (bitString.charAt(i) == '1')
                num++;
            else if (bitString.charAt(i) != '0')
                throw new IllegalArgumentException("Argument must represent 32 bits (1s and 0s).");
        }
        return num;
    }
    
    
    
    
    public static void testToBinaryString(int num)
    {
        System.out.println(Integer.toBinaryString(num));
    }
}