/**
 * IntegerBitUtil
 * 
 * @author Taylor Born
 * @version December 2013
 */
public abstract class IntegerBitUtil
{
    public static boolean[] intTo32Bits(int number)
    {
        boolean[] bits = new boolean[32];
        for (int i = bits.length - 1; i >= 0; i--)
        {
            bits[i] = number % 2 == 1;
            number = number >>> 1;
        }
        
        return bits;
    }
    public static int bitsToInt(boolean[] bits)
    {
        if (bits == null || bits.length != 32)
            throw new IllegalArgumentException("Not enough bits!");
        int number = 0;
        for (int i = 0; i < 32; i++)
        {
            number = number << 1;
            if (bits[i])
                number++;
        }
        return number;
    }
}