/**
 * OnlinePresence
 * 
 * @author Taylor Born
 * @version December 2013
 */
public class OnlinePresence
{
    private int lastNum;
    private Long lastActivity;
    
    private char gameStatus = '-'; // R, G

    public OnlinePresence(int num)
    {
        lastNum = num;
    }
    public void update(int num, char gs)
    {
        if (lastNum != num)
        {
            update();
            lastNum = num;
        }
        int secondsAgo = secondsAgoOfLastActivity();
        if (secondsAgo != -1 && secondsAgo < 15)
            gameStatus = gs;
        else
            gameStatus = '-';
    }
    public void update(int num)
    {
        if (lastNum != num)
        {
            update();
            lastNum = num;
        }
    }
    private void update()
    {
        lastActivity = System.currentTimeMillis();
    }
    public int secondsAgoOfLastActivity()
    {
        if (lastActivity == null)
            return -1;
        return (int)((System.currentTimeMillis() - lastActivity) / 1000);
    }
    public char getGameStatus()
    {
        return gameStatus;
    }
    
    @Override
    public String toString()
    {
        int lastActivity = secondsAgoOfLastActivity();
        if (lastActivity == -1)
            return "N/A";
        int hours = lastActivity / 3600;
        lastActivity = lastActivity % 3600;
        int minutes = lastActivity / 60;
        lastActivity = lastActivity % 60;
        return (hours > 0 ? (hours + "h ") : "") + (minutes > 0 ? (minutes + "m ") : "") + lastActivity + "s";
    }
}