import greenfoot.GreenfootImage;
import greenfoot.UserInfo;
import java.util.HashMap;

/**
 * UserIcons
 * 
 * @author Taylor Born
 * @version October 2013 - January 2014
 */
public class UserIcons
{
    private static HashMap<String, GreenfootImage> data = new HashMap<String, GreenfootImage>();
    private static GreenfootImage defaultIcon = new GreenfootImage("no_avatar_thumb.jpg");
    static
    {
        defaultIcon.scale(18, 18);
    }
    
    public static GreenfootImage commit(String userName, UserInfo user)
    {
        GreenfootImage icon = data.get(userName);
        if (icon != null)
            return icon;
        icon = user.getUserImage();
        icon.scale(18, 18);
        data.put(userName, icon);
        return icon;
    }
    public static GreenfootImage getIconFor(String userName)
    {
        GreenfootImage icon = data.get(userName);
        if (icon != null)
            return icon;
        return defaultIcon;
    }
    public static boolean loadedIconFor(String userName)
    {
        return data.get(userName) != null;
    }
}