/**
 * UserInfoSemaphore
 * 
 * @author Taylor Born
 * @version October 2013
 */
public abstract class UserInfoSemaphore
{
    private static volatile boolean busy = false;
    private static volatile int origPriority;
    
    public static synchronized boolean request()
    {
        if (busy)
            return false;
        origPriority = Thread.currentThread().getPriority();
        Thread.currentThread().setPriority(Thread.MAX_PRIORITY);
        busy = true;
        return true;
    }
    public static void release()
    {
        Thread.currentThread().setPriority(origPriority);
        busy = false;
    }
}